# Safe-text
Simple javascript safe-text for `node` and `browser`.
> keywords: Safe-text, Sanitize, HTML-entities, Strings, XSS

_________
## API:
````javascript
var safeText = require('safe-text');
````

### safeText(String, IgnoreCases)

#### String
String that you want to safe.
> e.g.  ````'"><script>alert(1)</script>'````

#### IgnoreCases
The Array of cases you don't wan't to safe.
> e.g. ````['&', ')([]{}*#', 'emails']````
* `emails` is a embedded list of characters used in email addresses.

##### Embedded character lists
* `emails`
* `urls`
* `markdown`

## Example
````javascript
var safeText = require('safe-text');

var str = '"><script>alert(1)</script><a href="http://example.tld/page.html">page</a>';
var ignore_cases = ['()/', 'urls'];

console.log(safeText(str, ignore_cases))
// &quot;&gt;&lt;script&gt;alert(1)&lt;/script&gt;&lt;a href=&quot;http://example.tld/page.html&quot;&gt;page&lt;/a&gt;
````
